<?php
 
 
 

namespace PhpWA\Protocol\Proto\SyncActionValue;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\GPBUtil;
use Google\Protobuf\RepeatedField;




class SyncActionMessageRange extends \Google\Protobuf\Internal\Message
{
    


    protected $lastMessageTimestamp = null;
    


    protected $lastSystemMessageTimestamp = null;
    


    private $messages;

    










    public function __construct($data = NULL) {
        \PhpWA\Protocol\Proto\Metadata\WAProto::initOnce();
        parent::__construct($data);
    }

    



    public function getLastMessageTimestamp()
    {
        return isset($this->lastMessageTimestamp) ? $this->lastMessageTimestamp : 0;
    }

    public function hasLastMessageTimestamp()
    {
        return isset($this->lastMessageTimestamp);
    }

    public function clearLastMessageTimestamp()
    {
        unset($this->lastMessageTimestamp);
    }

    




    public function setLastMessageTimestamp($var)
    {
        GPBUtil::checkInt64($var);
        $this->lastMessageTimestamp = $var;

        return $this;
    }

    



    public function getLastSystemMessageTimestamp()
    {
        return isset($this->lastSystemMessageTimestamp) ? $this->lastSystemMessageTimestamp : 0;
    }

    public function hasLastSystemMessageTimestamp()
    {
        return isset($this->lastSystemMessageTimestamp);
    }

    public function clearLastSystemMessageTimestamp()
    {
        unset($this->lastSystemMessageTimestamp);
    }

    




    public function setLastSystemMessageTimestamp($var)
    {
        GPBUtil::checkInt64($var);
        $this->lastSystemMessageTimestamp = $var;

        return $this;
    }

    



    public function getMessages()
    {
        return $this->messages;
    }

    




    public function setMessages($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::MESSAGE, \PhpWA\Protocol\Proto\SyncActionValue\SyncActionMessage::class);
        $this->messages = $arr;

        return $this;
    }

}

